Subject: Request arguments should never contain objects
Description
Request arguments are serialized in Fluid forms in order to generate the hidden referrer fields that are required to "replay" the last
request in case of an validation error. If a request argument is a complex type, the value of the __referrer[arguments] hidden field gets
huge which poses 3 major issues:
    1. you'll have to transfer a lot of unnecessary data
    2. the URI for redirects will grow to a point where the browser dies
    3. if an object is not serializable, you get serialization errors

Thus RoutePartHandler must not return objects. Instead they should return simple types/arrays understandable by the
PropertyMapper (or a dedicated ObjectConverter)

Discuss: Should this be enforced in the routing process?

Related issues:
related to TYPO3.Flow - Bug # 25902: It's not possible to add an entity as li... Resolved 2011-04-12
related to TYPO3.Flow - Task # 26078: Enforce RouteParts to only return simpl... Resolved 2011-04-18
related to TYPO3.Flow - Task # 25907: Referrer should only contain the URI of... New 2011-04-12

Associated revisions
Revision 4f8708ed - 2011-04-27 14:33 - Bastian Waidelich

[+BUGFIX] Request arguments should never contain objects

Request arguments are serialized in Fluid forms in order to generate the
hidden referrer fields that are required to "replay" the last request in
case of an validation error. If a request argument is a complex type,
the value of the __referrer[arguments] hidden field gets huge which
poses 3 major issues:

1. you'll have to transfer a lot of unnecessary data
2. the URI for redirects will grow to a point where the browser dies
3. if an object is not serializable, you get serialization errors

Fixes: #25801
Change-Id: Ia7b2c9972003c3f91170dc63db43ef2b3c15fc4e

History
#1 - 2011-04-12 11:54 - Bastian Waidelich

Note: We currently also add objects to the Request in ActionController::forward(). To make sure, we only have simple types in the request we could
convert objects to identity arrays in Request::setArgument().
See Route::convertDomainObjectsToIdentityArrays()

#2 - 2011-04-14 12:24 - Bastian Waidelich
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

#3 - 2011-04-14 12:31 - Mr. Hudson

Patch set 1 of change Ia7b2c9972003c3f91170dc63db43ef2b3c15fc4e has been pushed to the review server.
It is available at http://review.typo3.org/1604

#4 - 2011-04-14 14:10 - Mr. Hudson

Patch set 2 of change Ia7b2c9972003c3f91170dc63db43ef2b3c15fc4e has been pushed to the review server.
It is available at http://review.typo3.org/1604

#5 - 2011-04-27 14:06 - Mr. Hudson

Patch set 3 of change Ia7b2c9972003c3f91170dc63db43ef2b3c15fc4e has been pushed to the review server.
It is available at http://review.typo3.org/1604

#6 - 2011-04-27 14:33 - Mr. Hudson

Patch set 4 of change Ia7b2c9972003c3f91170dc63db43ef2b3c15fc4e has been pushed to the review server.
It is available at http://review.typo3.org/1604

#7 - 2011-04-27 15:00 - Bastian Waidelich
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4f8708ed15e7fca71921f58a9d1fb38dd6f28f13.

#8 - 2013-10-17 17:35 - Tim Spiekerkötter

Has this ever been backported to Extbase? I have a huge hidden [__referrer][arguments] field with several kb in size. That causes problems with the
fgci settings, and I wonder if I have done something wrong.

#9 - 2013-10-17 17:43 - Bastian Waidelich
- Has patch set to No
- Affected Flow version set to (any)

Tim Spiekerkötter wrote:
I have a huge hidden [__referrer][arguments] field with several kb in size. That causes problems with the fgci settings, and I wonder if I have done
something wrong.

The simple type restriction is not active for internal arguments (starting with __). But if your referrer arguments are that large there's probably
something wrong, yes

#10 - 2013-10-23 11:17 - Tim Spiekerkötter

Hi Bastian,

thank you for your answer. My request has two arguments, both are Extbase models and the FormViewHelper just serializes those arugments and
therefore generating a giant hidden field. I don't want to spam this Flow issue but I don't know if this is an Extbase issue or a problem within my
application.

Bastian Waidelich wrote:

Tim Spiekerkötter wrote:

I have a huge hidden [__referrer][arguments] field with several kb in size. That causes problems with the fgci settings, and I wonder if I have done
something wrong.

The simple type restriction is not active for internal arguments (starting with __). But if your referrer arguments are that large there's probably
something wrong, yes

#11 - 2013-10-23 11:37 - Bastian Waidelich

Tim Spiekerkötter wrote:

Hi Tim,

thank you for your answer. My request has two arguments, both are Extbase models [...]

You should refer to the Extbase bugtracker (http://forge.typo3.org/projects/show/typo3v4-mvc) or rather the Extbase forum (
http://forum.typo3.org/index.php/f/60/). Those guys have a better overview of the current state and what has been backported
